/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2023/12/29
 * Description        : Main program body.
 *********************************************************************************
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for 
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/

/*
 *@Note
 *task1 and task2 alternate printing
 */

#include "debug.h"
#include "FreeRTOS.h"
#include "task.h"

/* Global define */
#define TASK1_TASK_PRIO     5
#define TASK1_STK_SIZE      256
#define TASK2_TASK_PRIO     5
#define TASK2_STK_SIZE      256
#define TASK3_TASK_PRIO     5
#define TASK3_STK_SIZE      256

/* Global Variable */
TaskHandle_t Task1Task_Handler;
TaskHandle_t Task2Task_Handler;
TaskHandle_t Task3Task_Handler;

/*********************************************************************
 * @fn      GPIO_Toggle_INIT
 *
 * @brief   Initializes GPIOA.0/1
 *
 * @return  none
 */
#define DMA_Rx_Len 200
#define DMA_Tx_Len 5
u8      DMA_Rx_Buf[DMA_Rx_Len];     //DMAմݻ
u8      DMA_Tx_Buf[5]={1,2,3,4,5};     //DMAʹݻ
u16     Usart2_Rx_Cnt=0;             //֡ݳ
u8      j=0;
u8 usart_flag=0;


void USART2_CFG( void )
{
    NVIC_InitTypeDef   NVIC_InitStructure= {0};

    NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=2;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);

}
void DMA_rxINIT( void )
{
    DMA_InitTypeDef DMA_InitStructure = {0};
    RCC_AHBPeriphClockCmd( RCC_AHBPeriph_DMA1, ENABLE );

    DMA_DeInit( DMA1_Channel6);   //RXʼ
    DMA_InitStructure.DMA_PeripheralBaseAddr = ( u32 )( &USART2->DATAR );
    DMA_InitStructure.DMA_MemoryBaseAddr = ( u32 )DMA_Rx_Buf;
    DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC;
    DMA_InitStructure.DMA_BufferSize = DMA_Rx_Len;
    DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
    DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;
    DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;
    DMA_InitStructure.DMA_Mode = DMA_Mode_Normal;
    DMA_InitStructure.DMA_Priority = DMA_Priority_High;
    DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;
    DMA_Init( DMA1_Channel6, &DMA_InitStructure );
    DMA_Cmd( DMA1_Channel6, ENABLE );

}
void DMA_txINIT( void )
{
    DMA_InitTypeDef DMA_InitStructure = {0};
    NVIC_InitTypeDef NVIC_InitStructure={0};
    RCC_AHBPeriphClockCmd( RCC_AHBPeriph_DMA1, ENABLE );

    DMA_DeInit( DMA1_Channel7);   //RXʼ
    DMA_InitStructure.DMA_PeripheralBaseAddr = ( u32 )( &USART2->DATAR );
    DMA_InitStructure.DMA_MemoryBaseAddr = ( u32 )DMA_Rx_Buf;
    DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralDST;
    DMA_InitStructure.DMA_BufferSize = DMA_Rx_Len;
    DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
    DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte;
    DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;
    DMA_InitStructure.DMA_Mode = DMA_Mode_Normal;
    DMA_InitStructure.DMA_Priority = DMA_Priority_High;
    DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;
    DMA_Init( DMA1_Channel7, &DMA_InitStructure );

    NVIC_InitStructure.NVIC_IRQChannel =  DMA1_Channel7_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority=1;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
    DMA_ITConfig(DMA1_Channel7, DMA_IT_TC, ENABLE);
//    DMA_Cmd( DMA1_Channel7, ENABLE );
}
void DMA1_Channel7_IRQHandler(void) __attribute__((interrupt()));
void DMA1_Channel7_IRQHandler(void)
{
    if(DMA_GetITStatus(DMA1_IT_TC7)!= RESET)    //DMAɱ־
    {
        printf("DMA SEND OK\r\n");
        DMA_ClearITPendingBit(DMA1_IT_TC7);     //жϱ־
    }
}
void USART2_IRQHandler(void) __attribute__((interrupt()));
void USART2_IRQHandler(void)
{
    //ڿж
//    i++;
//    printf("ж%d\r\n",i);

    if(USART_GetITStatus(USART2, USART_IT_IDLE) != RESET)
    {
        USART_ClearITPendingBit(USART2, USART_IT_IDLE); //жϱ־

        USART_ReceiveData(USART2); //ȡ
        Usart2_Rx_Cnt = DMA_Rx_Len - DMA_GetCurrDataCounter(DMA1_Channel6); //ոڽջܴСѾյĸ
//        vTaskDelay(250);
//        printf("յΪ\r\n");
//        for(j=0;j<Usart2_Rx_Cnt;j++)
//        {
//            printf("%c",DMA_Rx_Buf[j]);
//        }

//        printf("\r\n");
        usart_flag=1;
        DMA_Cmd(DMA1_Channel6, DISABLE ); //ֹͣDMAͣ
        DMA_SetCurrDataCounter(DMA1_Channel6, DMA_Rx_Len); //DMAͨDMAĴС
        DMA_Cmd(DMA1_Channel6, ENABLE); //ʹUSART2 RX DMA ָʾͨ
     }
}
void GPIO_Toggle_INIT(void)
{
  GPIO_InitTypeDef  GPIO_InitStructure={0};

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA,ENABLE);
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
  GPIO_Init(GPIOA, &GPIO_InitStructure);
}


/*********************************************************************
 * @fn      task1_task
 *
 * @brief   task1 program.
 *
 * @param  *pvParameters - Parameters point of task1
 *
 * @return  none
 */
void task1_task(void *pvParameters)
{
    while(1)
    {
        printf("task1 entry\r\n");
        GPIO_SetBits(GPIOA, GPIO_Pin_0);
        vTaskDelay(250);
        GPIO_ResetBits(GPIOA, GPIO_Pin_0);
        vTaskDelay(250);
    }
}

/*********************************************************************
 * @fn      task2_task
 *
 * @brief   task2 program.
 *
 * @param  *pvParameters - Parameters point of task2
 *
 * @return  none
 */
void task2_task(void *pvParameters)
{
    while(1)
    {
        printf("task2 entry\r\n");
        GPIO_ResetBits(GPIOA, GPIO_Pin_1);
        vTaskDelay(500);
        GPIO_SetBits(GPIOA, GPIO_Pin_1);
        vTaskDelay(500);
    }
}


void task3_task(void *pvParameters)
{
    while(1)
    {

        if (usart_flag==1) {
//           printf("յΪ\r\n");
           usart_flag=0;
           DMA_Cmd( DMA1_Channel7, DISABLE );
           DMA1_Channel7->CNTR=Usart2_Rx_Cnt;
           DMA_Cmd( DMA1_Channel7, ENABLE);

        }
        vTaskDelay(500);

    }
}
/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);
    SystemCoreClockUpdate();
    Delay_Init();
    USART_Printf_Init(115200);
    printf("SystemClk:%d\r\n",SystemCoreClock);
    printf( "ChipID:%08x\r\n", DBGMCU_GetCHIPID() );
    printf("FreeRTOS Kernel Version:%s\r\n",tskKERNEL_VERSION_NUMBER);
    USART2_CFG();
    DMA_rxINIT();
    DMA_txINIT();
    GPIO_Toggle_INIT();
    /* create two task */
    xTaskCreate((TaskFunction_t )task2_task,
                        (const char*    )"task2",
                        (uint16_t       )TASK2_STK_SIZE,
                        (void*          )NULL,
                        (UBaseType_t    )TASK2_TASK_PRIO,
                        (TaskHandle_t*  )&Task2Task_Handler);

    xTaskCreate((TaskFunction_t )task1_task,
                    (const char*    )"task1",
                    (uint16_t       )TASK1_STK_SIZE,
                    (void*          )NULL,
                    (UBaseType_t    )TASK1_TASK_PRIO,
                    (TaskHandle_t*  )&Task1Task_Handler);

    xTaskCreate((TaskFunction_t )task2_task,
                            (const char*    )"task2",
                            (uint16_t       )TASK2_STK_SIZE,
                            (void*          )NULL,
                            (UBaseType_t    )TASK2_TASK_PRIO,
                            (TaskHandle_t*  )&Task2Task_Handler);

        xTaskCreate((TaskFunction_t )task3_task,
                        (const char*    )"task3",
                        (uint16_t       )TASK3_STK_SIZE,
                        (void*          )NULL,
                        (UBaseType_t    )TASK3_TASK_PRIO,
                        (TaskHandle_t*  )&Task3Task_Handler);
    vTaskStartScheduler();

    while(1)
    {
        printf("shouldn't run at here!!\n");
    }
}

